"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.randomString = exports.getServerUrlFromRequest = exports.indentText = exports.readPublicFile = exports.isLoopback = exports.isRequestingFromBrowser = void 0;
const promises_1 = __importDefault(require("node:fs/promises"));
const path = __importStar(require("path"));
const cliUserAgentStarts = [
    "curl/",
    "Wget/",
    "HTTPie/",
];
function isRequestingFromBrowser(req) {
    const ua = req.userAgent();
    return !cliUserAgentStarts.some(prefix => ua.startsWith(prefix));
}
exports.isRequestingFromBrowser = isRequestingFromBrowser;
function isLoopback(iface) {
    var _a, _b;
    return !!(((_a = iface.cidr) === null || _a === void 0 ? void 0 : _a.endsWith("/8")) && ((_b = iface.cidr) === null || _b === void 0 ? void 0 : _b.startsWith("127.")));
}
exports.isLoopback = isLoopback;
function readPublicFile(fileName) {
    const localPath = path.join(__dirname, "..", "public", fileName);
    return promises_1.default.readFile(localPath, { encoding: "utf8" });
}
exports.readPublicFile = readPublicFile;
function indentText(text, char = "\t", amount = 1) {
    const indent = char.repeat(amount);
    return text
        .split("\n")
        .map(l => indent + l)
        .join("\n");
}
exports.indentText = indentText;
function getServerUrlFromRequest(protocol, req, token, defaultIncludingPort) {
    const hostHeader = req.headers.host;
    if (hostHeader) {
        const hostHeaderWithoutTrailingSlash = hostHeader.trimRight().replace(/\/+$/, ""); // See: https://stackoverflow.com/a/6680877
        return protocol + "://" + hostHeaderWithoutTrailingSlash + "/" + token;
    }
    return protocol + "://" + defaultIncludingPort;
}
exports.getServerUrlFromRequest = getServerUrlFromRequest;
/**
 * Does not contain chars like 1/i/I/l and o/0/O
 */
const charset = "abcdefghjkmnpqrstuvwxyz123456789";
function randomString(length = 8) {
    const res = new Array(length);
    for (let i = 0; i < res.length; ++i) {
        const c = charset[(Math.random() * charset.length) | 0];
        res[i] = c;
    }
    return res.join("");
}
exports.randomString = randomString;
